package pwc.taxtech.atms.constant.enums;

import java.util.HashMap;
import java.util.Map;

public class BillDetailEnum {

    /**
     * 发票类型
     */
    public enum BillType {
        ORDINARY(1, "增值税普票"),
        SPECIAL(2, "增值税专票");
        private Integer code;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        BillType(Integer code, String name) {
            this.code = code;
            this.name = name;
        }

        public Integer getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BillDetailEnum.BillType billType : BillDetailEnum.BillType.values()) {
                MAPPING.put(billType.getCode(), billType.getName());
            }
        }
    }


}
