﻿citModule.controller('entryListModalController', ['$log', 'apiInterceptor', 'Upload', '$scope', '$q', '$translate', '$uibModal', '$document', '$rootScope', 'SweetAlert', 'enums',
    'vatReportService', 'loginContext', 'vatSessionService', 'stdAccountService', 'vatCommonService', 'formulaService', 'KeyValueConfigService', 'modelConfigurationService', '$timeout', 'cellCommentService', 'modifiedReportCellService','commonWebService',
    function ($log, apiInterceptor, Upload, $scope, $q, $translate, $uibModal, $document, $rootScope, SweetAlert, enums, vatReportService, loginContext,
              vatSessionService, stdAccountService, vatCommonService, formulaService, KeyValueConfigService, modelConfigurationService, $timeout, cellCommentService, modifiedReportCellService,commonWebService) {


        var entityInit = function () {
            //初始化值
            $scope.entry = {
                JFFSETotal: "",
                DFFSETotal: "",
                QMYETotalFirst: "",
                QMYETotalend: ""
            }
        }
        var _logIndex =0;
        if($scope.relObj.logs == undefined || $scope.relObj.logs.length == 0){
            $scope.relObj.logs = [];
        }
        entityInit();

        $scope.dataGridOptions = {
            bindingOptions: {
                columns: 'entryListColumns',
                dataSource: 'relObj.entryDataSource'
            },
            loadPanel: {
                enabled: false
            },
            scrolling: {
                mode: "standard"
            },
            selection: {
                mode: "multiple"
            },
            sorting: {
                mode: 'single'
            },
            filterRow: {
                visible: true
            },
            searchPanel: {
                visible: true,
                width: 240,
                placeholder: $translate.instant('SearchPlaceholder')
            },
            onSelectionChanged: function (selectedItems) {
                /* $scope.selectedItems = $.map(selectedItems.selectedRowsData, function (data) {
                     $scope.selectedAddDatasourceItems = selectedItems.selectedRowsData;
                     return data.id;
                 });

                 $log.debug($scope.selectedItems);*/

                name: "124600SYSADMIN20180900025 社保公积金 CNY"
                orgCode: "124600"
                orgName: "滴滴智慧交通科技有限公司"
                organizationId: "5bbd739c-1a13-4b0f-aba6-32ba41e4de69"
                period: 2018
                $scope.doCalcute(selectedItems.selectedRowsData);
                var _in = {};
                if(selectedItems.currentDeselectedRowKeys.length == 0){
                    _in.operate = "增";
                    _in.accountingDate = selectedItems.currentSelectedRowKeys[0].accountingDate;
                    _in.voucherNum = selectedItems.currentSelectedRowKeys[0].voucherNum;
                    _in.orgCode = selectedItems.currentSelectedRowKeys[0].orgCode;
                    _in.organizationId = selectedItems.currentSelectedRowKeys[0].organizationId;
                }else{
                    _in.operate = "减";
                    _in.accountingDate = selectedItems.currentDeselectedRowKeys[0].accountingDate;
                    _in.voucherNum = selectedItems.currentDeselectedRowKeys[0].voucherNum;
                    _in.orgCode = selectedItems.currentDeselectedRowKeys[0].orgCode;
                    _in.organizationId = selectedItems.currentDeselectedRowKeys[0].organizationId;

                }
                _in.subjectCode = $scope.relObj.entryLogIdByCode;
                $scope.relObj.logs.push(_in);
            },
            allowColumnResizing: true,
            hoverStateEnabled: true,
            showBorders: true,
            showRowLines: true,
            showColumnLines: true,
        };

        //设置数据源表格的列
        var getEntryListColumns = function () {
            var dataGridColumns;
            dataGridColumns = [
                {
                    dataField: 'index',
                    caption: $translate.instant('ImportErrorPopUpNoCol'),
                    alignment: 'center'
                },
                {
                    dataField: 'accountingDate',
                    caption: $translate.instant('JournalPZRQ'),
                    alignment: 'left',
                    dataType: 'date',
                    customizeText: function (cellInfo) {
                        if (cellInfo && cellInfo.value) {
                            return new Date(cellInfo.value).dateTimeToString('yyyyMMdd');
                        }
                        return "";
                    }
                },
                {
                    dataField: 'voucherNum',
                    caption: $translate.instant('AccountVoucher_DataGrid_ColVID'),
                    alignment: 'center'
                },
                {
                    dataField: 'description',
                    caption: $translate.instant('JournalZY'),
                    alignment: 'center'
                },
                {
                    dataField: 'accountedDr',//借方发生额
                    caption: $translate.instant('DebitAmount'),
                    alignment: 'right'
                },
                {
                    dataField: 'accountedCr',//贷方发生额
                    caption: $translate.instant('CreditAmount'),
                    alignment: 'right'
                },
            ];
            return dataGridColumns;
        };

        $scope.entryListColumns = getEntryListColumns();

        //确定
        $scope.makeSure = function () {
            $scope.relObj.checkRadio = $scope.check;
            $('#entryListModal').modal('hide');
        }

        $scope.cancel = function () {
            $('#entryListModal').modal('hide');
            //entityInit();
        }

        $scope.hideCellAttachmentModel = function () {
            $('#entryListModal').modal('hide');
            //entityInit();
        }

        //
        //配置计算公式进行计算
        $scope.doCalcute = function (data) {
            var v1 = 0;//借方发生额合计
            var v2 = 0//贷方发生额合计
            var _index = 0;
            data.forEach(function (item) {
                if (_index == 0) {
                    v1 = parseFloat(item.accountedDr);
                    v2 = parseFloat(item.accountedCr);
                } else {
                    v1 +=  parseFloat(item.accountedDr);
                    v2 +=  parseFloat(item.accountedCr);
                }
                _index++;
            });

            $scope.entry.JFFSETotal = v1.toFixed(2);
            $scope.entry.DFFSETotal = v2.toFixed(2);
            $scope.entry.QMYETotalFirst = (v2 - v1).toFixed(2);
            $scope.entry.QMYETotalend = (v1 - v2).toFixed(2);
        }

    }
]);