/**
 * Created by Administrator on 2019/3/1 0001.
 */
taxDocumentManageModule.factory('taxDocumentListService',
    ['$q', 'apiConfig', 'jqFetch','apiInterceptor',
        function ($q, apiConfig, jqFetch,apiInterceptor) {
            'use strict';
            return {
                fetchMainList: function (params) {
                    return jqFetch.post(apiInterceptor.webApiHostUrl + '/taxDoc/selectList', params);
                },
                addNewRecord: function (params) {

                    var defer = $q.defer();
                    window.$.ajax({
                        type: 'POST',
                        url: apiInterceptor.webApiHostUrl + '/taxDoc/add',
                        data: params,
                        dataType: "json",
                        beforeSend: function(request) {
                            request.setRequestHeader("Authorization", apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken());
                            request.setRequestHeader("Content-Type", 'application/x-www-form-urlencoded');
                            request.setRequestHeader("Accept", "*/*");
                        },
                        success: function(result) {
                            $('#busy-indicator-container').hide();
                            defer.resolve(result);
                        },
                        error:function(result){
                            $('#busy-indicator-container').hide();
                            defer.reject(result);
                        }
                    });
                    return defer.promise;


                },
                editRecord: function (params) {
                    $('#busy-indicator-container').show();
                    var defer = $q.defer();
                    window.$.ajax({
                        type: 'POST',
                        url: apiInterceptor.webApiHostUrl + '/taxDoc/edit',
                        data: params,
                        dataType: "json",
                        beforeSend: function(request) {
                            request.setRequestHeader("Authorization", apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken());
                            // request.setRequestHeader("Content-Type", 'multipart/form-data; boundary=----WebKitFormBoundaryNBBkL3vAiuTDbAZP');
                            request.setRequestHeader("Content-Type", 'application/x-www-form-urlencoded');
                            request.setRequestHeader("Accept", "*/*");
                        },
                        success: function(result) {
                            $('#busy-indicator-container').hide();
                            defer.resolve(result);
                        },
                        error:function(result){
                            $('#busy-indicator-container').hide();
                            defer.reject(result);
                        }
                    });
                    return defer.promise;
                },
                verifyDuplicate:function(params){
                    return jqFetch.post(apiInterceptor.webApiHostUrl + '/taxDoc/queryWhetherData', params);
                },
                getFileInfoOptions:function(params){
                    return jqFetch.post(apiInterceptor.webApiHostUrl + '/fileTypes/query4SelectionBox', params);
                },
                getCompanyNameOptions:function(params){
                    return jqFetch.get(apiInterceptor.webApiHostUrl + '/org/getMyOrgList', params);
                },
                delFileRecordItems:function(params){
                    return jqFetch.post(apiInterceptor.webApiHostUrl + '/taxDoc/batchDelete', params);
                },
                getDocumentsAttrAndType:function(params){
                    return jqFetch.post(apiInterceptor.webApiHostUrl + '/fileTypes/selectList', params);
                },
                getBusinessList:function(params){
                    return jqFetch.get(apiInterceptor.webApiHostUrl + '/businessunit/getlist', params);
                },
                downloadAllFile:function(params){
                    var xhr = new XMLHttpRequest();
                    var fileName = 'files.zip'; // 文件名称
                    xhr.open('POST', apiInterceptor.webApiHostUrl + "/taxDoc/downloadAllFile", true);
                    xhr.responseType = 'arraybuffer';
                    // xhr.setRequestHeader(token, 'xxxxx') ;// 请求头中的验证信息等（如果有）

                    xhr.setRequestHeader("Authorization", apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken());
                    xhr.setRequestHeader("Content-Type", 'application/json;charset=UTF-8');
                    xhr.onload = function() {
                        if (this.status === 200) {
                            // let type = xhr.getResponseHeader('Content-Type');

                            var blob = new Blob([this.response], {type: "arraybuffer"});
                            if (typeof window.navigator.msSaveBlob !== 'undefined') {
                                /*
                                 * IE workaround for "HTML7007: One or more blob URLs were revoked by closing
                                 * the blob for which they were created. These URLs will no longer resolve as
                                 * the data backing the URL has been freed."
                                 */
                                window.navigator.msSaveBlob(blob, fileName)
                            } else {
                                var URL = window.URL || window.webkitURL;
                                var objectUrl = URL.createObjectURL(blob);
                                if (fileName) {
                                    var a = document.createElement('a');
                                    // safari doesn't support this yet
                                    if (typeof a.download === 'undefined') {
                                        window.location = objectUrl
                                    } else {
                                        a.href = objectUrl;
                                        a.download = fileName;
                                        document.body.appendChild(a);
                                        a.click();
                                        a.remove();
                                    }
                                } else {
                                    window.location = objectUrl;
                                }
                            }
                        }
                    };
                    xhr.send(JSON.stringify(params));

                },
                readXLSX:function(params){
                    return jqFetch.post(apiInterceptor.webApiHostUrl + '/taxDoc/previewExcelToJson', params);
                },
                getBinaryData:function(url){
                    var defer = $q.defer();
                    var oReq = new XMLHttpRequest();
                    oReq.onload = function(e) {
                        var arraybuffer = oReq.response;
                        console.info("arraybuffer:",arraybuffer);
                        defer.resolve(arraybuffer);
                    };
                    oReq.open("GET", url, true);
                    oReq.responseType = "arraybuffer";
                    oReq.send();

                    return defer.promise;
                }
            };
        }]);